unit Bag;

interface
uses SysUtils, WinTypes, WinProcs, Hlpdll32;
function ExportBag( HelpFileName, BagFileName, DosFileName : PChar; qError : pME ):
	THandle;Export;{$IFDEF Win32} StdCall;{$ENDIF}


implementation
{ GetBagFile() 'snags the bag' for whatever purpose another function might
	want to use it, e.g. onscreen display or save-to-disk.}
function ExportBag( HelpFileName, BagFileName, DosFileName : PChar; qError : pME ):
	THandle;Export;{$IFDEF Win32} StdCall;{$ENDIF}
const hfsHlp:	THandle = 0;
	hfBag:	THandle = 0;
	hMem:		THandle = 0;
	BufferSize = 32768;
var BytesRead: Longint;
	Buffer : Pointer;
	OutFile : File;

label EXITBAG;

begin
{ Open the internal file system }
	hfsHlp := HfsOpenSz( HelpFileName, fFSOpenReadOnly );
		MessageBox(0,'Hfs system open','',0);
		if hfsHlp = 0 then begin
			qError^.fwFlags := fwMERR_ABORT;
			qError^.wError := wMERR_PARAM;
			goto EXITBAG;
		end;
{ Open the baggaged file...must be larger than 550 bytes in 32 bit Help }
	hfBag := HfOpenHfs( hfsHlp, BagFileName, fFSOpenReadOnly );
{	MessageBox(0,'File queried','',0);}
	if hfBag = 0 then begin
		qError^.fwFlags := fwMERR_RETRY;
		qError^.wError := wMERR_MESSAGE;
		StrFmt( qError^.rgchError,'Unable to access requested file.',[BagFileName]);
		goto EXITBAG;
	end;
{Allocate memory for the copy buffer}
  GetMem (Buffer, BufferSize);
  If Buffer = Nil Then Begin
	qError^.fwFlags := fwMERR_Abort;
	qError^.wError := wMERR_Memory;
	Goto ExitBag;
  End;

{Create the output file}
  AssignFile(OutFile, DosFileName);
  Rewrite (OutFile, 1);
  If IoResult <> 0 Then Begin
	qError^.fwFlags := fwMERR_Abort;
	qError^.wError := wMERR_Message;
	StrCat(StrCat(StrCopy (qError^.rgchError,'Could not open output file "'),
		DosFileName),'".');
	Goto ExitBag;
  End;
 {Read each block from the bag file and write it to the output file. Exit on EOF or error.}

  Repeat
	BytesRead := LcbReadHf (hfBag, Buffer^, BufferSize);
	If BytesRead = -1 Then Begin
		qError^.fwFlags := fwMERR_Abort;
		qError^.wError := wMERR_Message;
		StrCat(StrCat(StrCopy (qError^.rgchError,'Error reading baggage file "'),
		BagFileName),'".');
		Goto ExitBag;
	End;
	BlockWrite(OutFile,Buffer^,BytesRead,Result);
	If (IoResult <> 0) or (Result <> BytesRead) Then Begin
		qError^.fwFlags := fwMERR_Abort or fwMERR_Retry;
		qError^.wError := wMERR_Message;
		StrCat(StrCat(StrCopy (qError^.rgchError, 'Error writing file "'),
			DosFileName),'".');
	  Goto ExitBag;
	End;
  Until BytesRead <> BufferSize;

ExitBag:  {Close files and deallocate memory}
	CloseFile(OutFile);  {Close output file}
	If Buffer <> Nil Then FreeMem (Buffer, BufferSize);  {free the buffer}
	If hfBag <> 0 Then RcCloseHf (hfBag);  {close the baggage file}
	If hfsHlp <> 0 Then RcCloseHfs (hfsHlp);  {Close the help file system}
	If qError^.wError <> wMERR_None Then begin
		Erase(OutFile); {If error, delete the DOS file}
		MessageBox(GetActiveWindow,'Potential file corruption...erasing extracted file.','Extraction error detected',16);
	end;
End;




(*{ Speicher allokieren }
hMem := GlobalAlloc( GMEM_MOVEABLE, lSize + 1 );
if hMem = 0 then
begin
	qError^.fwFlags := fwMERR_ABORT;
  qError^.wError := wMERR_MEMORY;
  goto EXITBAG;
end;

{ Read file from baggage into memory }
pMem := GlobalLock( hMem );
lBytesRead := LcbReadHf( hfBag, pMem^, lSize );
if lBytesRead = -1 then
begin
	qError^.fwFlags := fwMERR_ABORT;
	qError^.wError := wMERR_MESSAGE;
	StrFmt( qError^.rgchError,'Unable to read %s into memory.',[pszBagFileName] );
  goto EXITBAG;
end;

pMem[lSize] := #0;
GlobalUnlock(hMem);
{ Aufrumen }
EXITBAG:
{ Baggage-Datei schlieen }
if hfBag <> 0 then RcCloseHf( hfBag );
{ Hilfedatei-System schlieen }
if hfsHlp <> 0 then RcCloseHfs( hfsHlp );
Result := hMem;
end;*)

end.
